<template>
  <md-toolbar
    md-elevation="0"
    class="md-transparent pb-0"
    :class="{
      'md-toolbar-absolute md-white md-fixed-top': $route.meta.navbarAbsolute,
    }"
  >
    <!-- News -->
    <div v-if="configs && configs.sidebar_items.news" class="md-layout">
      <div class="md-layout-item tb-alert-warning">
        <p
          v-for="article in articles"
          :key="article.html_url"
          class="mb-1 mt-1"
        >
          <a class="latest-article" :href="article.html_url" target="_blank">
            {{ article.updated_at | moment_without_tz }}
            <b>{{ article.title }}</b>
          </a>
        </p>
      </div>
    </div>

    <div class="md-layout">
      <div class="md-layout-item md-size-90" style="width: 100%">
        <ul class="bread-crum mb-0 mt-2 ml-0 pl-0 mb-5">
          <li v-for="(breadCrumb, index) in breadCrumbs" :key="breadCrumb.name">
            <md-button
              v-if="breadCrumb.path != null"
              class="md-success bread-button"
              :to="'/console' + breadCrumb.path"
              >{{ $t(breadCrumb.name) }}</md-button
            >
            <div v-else class="inline-block mt-2" style="color: #959595">
              {{ $t(breadCrumb.name) }}
            </div>

            <md-icon
              v-if="breadCrumbs.length - 1 > index"
              class="mt-0"
              style="color: #959595"
              >keyboard_arrow_right</md-icon
            >
          </li>
        </ul>
      </div>
      <div class="md-layout-item md-size-10">
        <md-button
          class="md-just-icon md-round md-simple md-toolbar-toggle tb-right"
          :class="{ toggled: $sidebar.showSidebar }"
          @click="toggleSidebar"
        >
          <span class="icon-bar"></span>
          <span class="icon-bar"></span>
          <span class="icon-bar"></span>
        </md-button>
        <!--
        <div class="md-collapse">
          <md-list>
            <md-list-item href="/console/users/@me">
              <i class="material-icons">person</i>
              <p class="hidden-lg hidden-md">{{ $t("account") }}</p>
            </md-list-item>
          </md-list>
        </div>
        -->
      </div>
    </div>
  </md-toolbar>
</template>

<script>
import { mapActions } from 'vuex';
export default {
  props: ['current_user', 'configs', 'breadCrumbs'],
  data() {
    return {
      articles: null,
    };
  },
  mounted() {
    // document.title = this.changePageTitle(this.$route.name);
    this.fetchConsoleNews()
      .then((res) => {
        this.articles = res.data;
      })
      .catch((err) => {
        // ログインしてないときもあるのでエラーメッセージは省略する
        // FIX ME: 現在404ステータスになっている、適切なエラーに要変更
        if (err == 'Error: Request failed with status code 404') {
          sessionStorage.setItem(
            'uri',
            '/console/#' + this.$router.currentRoute.value.fullPath
          );
          sessionStorage.setItem('message', this.$t('csrf_message'));
          sessionStorage.setItem('type', 'danger');
          document.location = '/accounts/sign_out';
        } else {
          this.displayErrorNotify(err);
        }
      });
  },
  methods: {
    ...mapActions(['fetchConsoleNews']),
    toggleSidebar() {
      this.$sidebar.displaySidebar(!this.$sidebar.showSidebar);
    },
    minimizeSidebar() {
      if (this.$sidebar) {
        this.$sidebar.toggleMinimize();
      }
    },
    changePageTitle: function (name) {
      return this.$t(name) + ' | ' + this.$t('mypage');
    },
  },
  watch: {
    $route: function (val) {
      document.title = this.changePageTitle(val.name);
    },
  },
};
</script>

<style scoped lang="scss">
.md-toolbar-section-start {
  display: inline;
}
.bread-crum {
  list-style: none;
}
.bread-button {
  height: 30px !important;
  margin-top: 5px !important;
}
::v-deep .md-button-content {
  font-size: 12px !important;
}
.bread-crum li {
  display: inline;
}
.route-title {
  font-size: 28px;
  margin-bottom: 0;
}
::v-deep .latest-article {
  color: black !important;
  font-weight: bold;
}
</style>
